from sqlalchemy import *
from migrate import *
import migrate.changeset

def getIndices(meta):
    tmcsalerestrict1 = Table('tmcsalerestrict1', meta, autoload=True)
    tmcsalerestrict2 = Table('tmcsalerestrict2', meta, autoload=True)
    
    indices = [
        Index('tmcsalerestricttmccode', tmcsalerestrict1.c.tmccode, unique=False),
    
        Index('tmcsalerestricttmccode', tmcsalerestrict2.c.tmccode, unique=False)
    ]
    return indices


def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for index in getIndices(meta):
        index.create()

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    for index in getIndices(meta):
        index.drop()
