from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper

def getTables(meta):
  ds1 = Table('discountsystem1', meta, autoload=True)
  ds2 = Table('discountsystem2', meta, autoload=True)
  return [ds1, ds2]

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    meta = MetaData(bind = migrate_engine)
    for tbl in getTables(meta):
        updateTime = Column('update_time', TIMESTAMP, nullable = False, server_default=text("CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP"))
        if not updateTime.name in tbl.columns:
            updateTime.create(tbl)
    views_helper.update_dic_view(migrate_engine, 'discountsystem')
                                
                                
def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    tblname = views_helper.get_table_name(migrate_engine,'discountsystem')
    conn = migrate_engine.connect()
    for tbl in getTables(meta):
        if 'update_time' in tbl.columns:
            tbl.c.update_time.drop()    
    views_helper.update_dic_view(migrate_engine, 'discountsystem',tblname)
