from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

table_name = 'excisemarkwhite'
oldPrimaryKey = ('excisemarkid', 'excisetype')
newPrimaryKey = ('excisemarkid', 'barcode', 'excisetype')


def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    conn = migrate_engine.connect()
    for table in views_helper.getTables(meta, table_name):
        constraint.PrimaryKeyConstraint(*oldPrimaryKey, table=table).drop()
        # Пришлось писать запрос вручную. sqlalchemy может обрезать используемую длину поля только для индексов
        conn.execute("ALTER TABLE dictionaries.%s "
                     "ADD PRIMARY KEY (excisemarkid, barcode(45), excisetype)" % table)
    conn.close()
    views_helper.update_dic_view(migrate_engine, table_name)


def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    conn = migrate_engine.connect()
    for table in views_helper.getTables(meta, table_name):
        table.c.barcode.alter(nullable=True)
        pk = constraint.PrimaryKeyConstraint(*newPrimaryKey, table=table)
        pk.drop()

        conn.execute("ALTER TABLE dictionaries.%s "
                     "ADD PRIMARY KEY (excisemarkid, excisetype)" % table)
    conn.close()
    views_helper.update_dic_view(migrate_engine, table_name)
