from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getRemainDarftBeerTable(meta):
    return Table('remaindraftbeer', meta,
        Column('markingcode', String(255), nullable=False, primary_key=True),
        Column('barcode', String(255), nullable=False),
        Column('name', String(255), nullable=False),
        Column('connectdate', DateTime, nullable=False),
        Column('expirationdate', DateTime, nullable=True),
        Column('volume', Numeric(precision=13, scale=3), nullable=False),
    )

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.create_table(migrate_engine, getRemainDarftBeerTable(meta))

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    views_helper.drop_table(migrate_engine, getRemainDarftBeerTable(meta))
