from sqlalchemy import *
from migrate import *

def getWorkshiftIndex(meta):
    workshift = Table('workshift', meta, autoload=True)
    return Index('workshiftunique', workshift.c.shiftnum, workshift.c.cashcode, workshift.c.shifttype, unique=True)

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    getWorkshiftIndex(meta).create()

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.
    getWorkshiftIndex(meta).drop()
