# -*- coding: utf-8 -*-
from sqlalchemy import *
from migrate import *
import migrate.changeset

class T(object):
	classattr = "attr on class"

def getTables(meta):
	tables = T()
	tables.document = Table('document', meta, autoload=True)
	tables.goodsitem = Table('goodsitem', meta, autoload=True)
	tables.stornogoodsitem = Table('stornogoodsitem', meta, autoload=True)
	tables.department = Table('department', meta, autoload=True)
	tables.client = Table('client', meta, autoload=True)
	tables.paymentitem = Table('paymentitem', meta, autoload=True)
	tables.discitem = Table('discitem', meta, autoload=True)
	tables.carditem = Table('carditem', meta, autoload=True)
	tables.workshift = Table('workshift', meta, autoload=True)
	tables.moneyitem = Table('moneyitem', meta, autoload=True)
	tables.button = Table('button', meta, autoload=True)
	tables.aspectitem = Table('aspectitem', meta, autoload=True)
	tables.bonusitem = Table('bonusitem', meta, autoload=True)
	return tables

def upgrade(migrate_engine):
	meta = MetaData(bind = migrate_engine)
# dropping old foreign keys
	tables = getTables(meta)
	migrate.changeset.constraint.ForeignKeyConstraint([tables.aspectitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'aspectitemgoodsitemidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'bonusitemgoodsitemidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.documentid], [tables.document.c.documentid], name = 'bonusitemdocumentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.documentid], [tables.document.c.documentid], name = 'carditemdocumentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemidcardfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.department.c.clientitemid], [tables.client.c.clientitemid], name = 'departmentclientitemidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.buttonid], [tables.button.c.buttonid], name = 'discitembuttonidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.carditemid], [tables.carditem.c.carditemid], name = 'discitemcarditemidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'discitemgoodsitemidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.departmentid], [tables.department.c.departmentid], name = 'documentdepartmentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemiddocfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.buttonid], [tables.button.c.buttonid], name = 'documentbuttonidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.workshiftid], [tables.workshift.c.workshiftid], name = 'documentworkshiftidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.linkeddocumentid], [tables.document.c.documentid], name = 'linkeddocumentidfk').drop()  
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.departmentid], [tables.department.c.departmentid], name = 'goodsitemdepartmentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.buttonid], [tables.button.c.buttonid], name = 'goodsitembuttonidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.documentid], [tables.document.c.documentid], name = 'goodsitemdocumentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'goodsitempaymentitemidfk').drop()  
	migrate.changeset.constraint.ForeignKeyConstraint([tables.moneyitem.c.documentid], [tables.document.c.documentid], name = 'moneyitemdocumentidfk').drop()          
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.departmentid], [tables.department.c.departmentid], name = 'stornogoodsitemdepartmentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.buttonid], [tables.button.c.buttonid], name = 'stornogoodsitembuttonidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.documentid], [tables.document.c.documentid], name = 'stornogoodsitemdocumentidfk').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'stornogoodsitempaymentitemidfk').drop()
# creating new foreign keys
	migrate.changeset.constraint.ForeignKeyConstraint([tables.aspectitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'aspectitemgoodsitemidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'bonusitemgoodsitemidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.documentid], [tables.document.c.documentid], name = 'bonusitemdocumentidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.documentid], [tables.document.c.documentid], name = 'carditemdocumentidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemidcardfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.department.c.clientitemid], [tables.client.c.clientitemid], name = 'departmentclientitemidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.buttonid], [tables.button.c.buttonid], name = 'discitembuttonidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.carditemid], [tables.carditem.c.carditemid], name = 'discitemcarditemidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'discitemgoodsitemidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.departmentid], [tables.department.c.departmentid], name = 'documentdepartmentidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemiddocfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.buttonid], [tables.button.c.buttonid], name = 'documentbuttonidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.workshiftid], [tables.workshift.c.workshiftid], name = 'documentworkshiftidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.linkeddocumentid], [tables.document.c.documentid], name = 'linkeddocumentidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.departmentid], [tables.department.c.departmentid], name = 'goodsitemdepartmentidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.buttonid], [tables.button.c.buttonid], name = 'goodsitembuttonidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.documentid], [tables.document.c.documentid], name = 'goodsitemdocumentidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'goodsitempaymentitemidfk', ondelete = 'SET NULL').create() 
	migrate.changeset.constraint.ForeignKeyConstraint([tables.moneyitem.c.documentid], [tables.document.c.documentid], name = 'moneyitemdocumentidfk', ondelete = 'CASCADE').create()   
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.departmentid], [tables.department.c.departmentid], name = 'stornogoodsitemdepartmentidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.buttonid], [tables.button.c.buttonid], name = 'stornogoodsitembuttonidfk', ondelete = 'SET NULL').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.documentid], [tables.document.c.documentid], name = 'stornogoodsitemdocumentidfk', ondelete = 'CASCADE').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'stornogoodsitempaymentitemidfk', ondelete = 'SET NULL').create()
   
def downgrade(migrate_engine):
	meta = MetaData(bind = migrate_engine)
# dropping old foreign keys	
	tables = getTables(meta)
	migrate.changeset.constraint.ForeignKeyConstraint([tables.aspectitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'aspectitemgoodsitemidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'bonusitemgoodsitemidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.documentid], [tables.document.c.documentid], name = 'bonusitemdocumentidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.documentid], [tables.document.c.documentid], name = 'carditemdocumentidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemidcardfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.department.c.clientitemid], [tables.client.c.clientitemid], name = 'departmentclientitemidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.buttonid], [tables.button.c.buttonid], name = 'discitembuttonidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.carditemid], [tables.carditem.c.carditemid], name = 'discitemcarditemidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'discitemgoodsitemidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.departmentid], [tables.department.c.departmentid], name = 'documentdepartmentidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemiddocfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.buttonid], [tables.button.c.buttonid], name = 'documentbuttonidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.workshiftid], [tables.workshift.c.workshiftid], name = 'documentworkshiftidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.linkeddocumentid], [tables.document.c.documentid], name = 'linkeddocumentidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.departmentid], [tables.department.c.departmentid], name = 'goodsitemdepartmentidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.buttonid], [tables.button.c.buttonid], name = 'goodsitembuttonidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.documentid], [tables.document.c.documentid], name = 'goodsitemdocumentidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'goodsitempaymentitemidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.moneyitem.c.documentid], [tables.document.c.documentid], name = 'moneyitemdocumentidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.departmentid], [tables.department.c.departmentid], name = 'stornogoodsitemdepartmentidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.buttonid], [tables.button.c.buttonid], name = 'stornogoodsitembuttonidfk', ondelete = 'SET NULL').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.documentid], [tables.document.c.documentid], name = 'stornogoodsitemdocumentidfk', ondelete = 'CASCADE').drop()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'stornogoodsitempaymentitemidfk', ondelete = 'SET NULL').drop()
# creating new foreign keys
	migrate.changeset.constraint.ForeignKeyConstraint([tables.aspectitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'aspectitemgoodsitemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'bonusitemgoodsitemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.bonusitem.c.documentid], [tables.document.c.documentid], name = 'bonusitemdocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.documentid], [tables.document.c.documentid], name = 'carditemdocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.carditem.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemidcardfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.department.c.clientitemid], [tables.client.c.clientitemid], name = 'departmentclientitemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.buttonid], [tables.button.c.buttonid], name = 'discitembuttonidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.carditemid], [tables.carditem.c.carditemid], name = 'discitemcarditemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.discitem.c.goodsitemid], [tables.goodsitem.c.goodsitemid], name = 'discitemgoodsitemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.departmentid], [tables.department.c.departmentid], name = 'documentdepartmentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.clientitemid], [tables.client.c.clientitemid], name = 'clientitemiddocfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.buttonid], [tables.button.c.buttonid], name = 'documentbuttonidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.workshiftid], [tables.workshift.c.workshiftid], name = 'documentworkshiftidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.document.c.linkeddocumentid], [tables.document.c.documentid], name = 'linkeddocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.departmentid], [tables.department.c.departmentid], name = 'goodsitemdepartmentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.buttonid], [tables.button.c.buttonid], name = 'goodsitembuttonidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.documentid], [tables.document.c.documentid], name = 'goodsitemdocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.goodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'goodsitempaymentitemidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.moneyitem.c.documentid], [tables.document.c.documentid], name = 'moneyitemdocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.departmentid], [tables.department.c.departmentid], name = 'stornogoodsitemdepartmentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.buttonid], [tables.button.c.buttonid], name = 'stornogoodsitembuttonidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.documentid], [tables.document.c.documentid], name = 'stornogoodsitemdocumentidfk').create()
	migrate.changeset.constraint.ForeignKeyConstraint([tables.stornogoodsitem.c.paymentitemid], [tables.paymentitem.c.paymentitemid], name = 'stornogoodsitempaymentitemidfk').create()

