from sqlalchemy import *
from migrate import *
from documents.versions import dump

indexName = 'goodsitemexcisemarkidx'
tableName = 'goodsitem'

def getTable(meta):
    return Table(tableName, meta, autoload=True)

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)
    tbl = getTable(meta)
    if indexName not in [ind.name for ind in tbl.indexes]:
        Index(indexName, tbl.c.excisemark).create()

def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    tbl = getTable(meta)
    if indexName in [ind.name for ind in tbl.indexes]:
        Index(indexName, tbl.c.excisemark).drop()
