from sqlalchemy import *
from migrate import *
import migrate.changeset

def getDocument(meta):
    return Table('document', meta, autoload=True)

def getCertificate(meta):
    certificate=Table('certificate', meta,
        Column('certificateid', Integer, nullable=False, primary_key=True, autoincrement=True),
        Column('documentid', Integer, ForeignKey(getDocument(meta).c.documentid, name='certificatedocumentidfk', ondelete='CASCADE'), nullable=False),
        Column('number', String(30), nullable=False),
        Column('code', String(30), nullable=False),
        Column('name', String(100), nullable=True),
        Column('sum', Numeric(precision=13, scale=2), nullable=False),
        Column('paymentsum', Numeric(precision=13, scale=2), nullable=False),
        Column('balance', Numeric(precision=13, scale=2), nullable=False),
        Column('fullyspend', Integer, nullable=False),
        mysql_engine='InnoDB',
    )
    return certificate

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    certificate = getCertificate(meta)
    if not certificate.exists(meta.bind):
        certificate.create()

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    certificate = getCertificate(meta)
    if certificate.exists(meta.bind):
        certificate.drop()
