from sqlalchemy import *
from migrate import *

def getTables(meta):
    return Table('kkm', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if not 'unsenddoccount' in tbl.columns:
        Column('unsenddoccount', Integer, nullable=True).create(tbl)
    if not 'unsenddocdate' in tbl.columns:
        Column('unsenddocdate', DateTime, nullable=True).create(tbl)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if 'unsenddoccount' in tbl.columns:
        Column('unsenddoccount', Integer, nullable=True).drop(tbl)
    if 'unsenddocdate' in tbl.columns:
        Column('unsenddocdate', DateTime, nullable=True).drop(tbl)