from sqlalchemy import *
from migrate import *
from documents.versions import dump

objectColumnName = 'paymentobject'
methodColumnName = 'paymentmethod'

def getTables(meta):
    goodsitem = Table('goodsitem', meta, autoload = True)
    stornogoodsitem = Table('stornogoodsitem', meta, autoload = True)
    return [goodsitem, stornogoodsitem]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    dump.store(migrate_engine)

    for table in getTables(meta):
        if objectColumnName not in table.columns:
            Column(objectColumnName, Integer, nullable = True).create(table)
        if methodColumnName not in table.columns:
            Column(methodColumnName, Integer, nullable = True).create(table)

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)

    for table in getTables(meta):
        if objectColumnName in table.columns:
            Column(objectColumnName, Integer, nullable = True).drop(table)
        if methodColumnName in table.columns:
            Column(methodColumnName, Integer, nullable = True).drop(table)
